## org.eclipse.m2m.atl.engine.vm
Class ASMEmitter

    java.lang.Object
      org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject
          org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny
              org.eclipse.m2m.atl.engine.vm.ASMEmitter

    public class ASMEmitter

extends ASMOclAny

This class is used by ATL compiler to create an ASM file.

Field Summary
`static ASMOclType` `myType`

Fields inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject
`nativeImpl`

Constructor Summary
`ASMEmitter()`

Method Summary
`void` `addField(java.lang.String name, java.lang.String type)`
`void` `addLineNumberEntry(java.lang.String id, int begin, int end)`
`void` `addLocalVariableEntry(int slot, java.lang.String name, int begin, int end)`
`void` `addOperation(java.lang.String name)`
`void` `addOperationWithoutLVE(java.lang.String name)`
`void` `addParameter(java.lang.String name, java.lang.String type)`
`void` `addParameterWithoutLVE(java.lang.String name, java.lang.String type)`
`void` `beginLineNumberEntry(java.lang.String id)`
`void` `beginLocalVariableEntry(java.lang.String id, java.lang.String name)`
`void` `dumpASM(java.lang.String fileName)`
`void` `emit(java.lang.String mnemonic, java.lang.String param)`
`void` `emitSimple(java.lang.String mnemonic)`
`void` `emitWithoutLabel(java.lang.String mnemonic, java.lang.String param)`
`void` `endLineNumberEntry(java.lang.String id)`
`void` `endLocalVariableEntry(java.lang.String id)`
`void` `finishOperation()`
`ASM` `getASM()`
`java.lang.String` `getVersion()`
`void` `newASM(java.lang.String name)`
`void` `newUnnamedASM()`
`void` `setContext(java.lang.String type)`
`void` `setName(java.lang.String name)`
`void` `setVersion(java.lang.String version)`

Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny
`asBag, asSequence, asSet, check, debug, findOperation, findOperation, get, getHelper, getNamedTargetFromSource, getOclAnyType, getType, invoke, invoke, invokeSuper, isHelper, oclIsKindOf, oclIsTypeOf, oclIsUndefined, oclType, operatorEQ, operatorNE, output, refGetValue, refImmediateComposite, refImmediateComposite, refInvokeOperation, refSetValue, refUnsetValue, set, setType, toString, unset`

Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject
`getNativeImpl`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### myType

    public static ASMOclType myType

Constructor Detail

### ASMEmitter

    public ASMEmitter()

Method Detail

### newASM

    public void newASM(java.lang.String name)

### newUnnamedASM

    public void newUnnamedASM()

### setName

    public void setName(java.lang.String name)

### addField

    public void addField(java.lang.String name,
                         java.lang.String type)

### finishOperation

    public void finishOperation()

### addOperation

    public void addOperation(java.lang.String name)

### addOperationWithoutLVE

    public void addOperationWithoutLVE(java.lang.String name)

### setContext

    public void setContext(java.lang.String type)

### addParameter

    public void addParameter(java.lang.String name,
                             java.lang.String type)

### addParameterWithoutLVE

    public void addParameterWithoutLVE(java.lang.String name,
                                       java.lang.String type)

### beginLineNumberEntry

    public void beginLineNumberEntry(java.lang.String id)

### endLineNumberEntry

    public void endLineNumberEntry(java.lang.String id)

### addLineNumberEntry

    public void addLineNumberEntry(java.lang.String id,
                                   int begin,
                                   int end)

### beginLocalVariableEntry

    public void beginLocalVariableEntry(java.lang.String id,
                                        java.lang.String name)

### endLocalVariableEntry

    public void endLocalVariableEntry(java.lang.String id)

### addLocalVariableEntry

    public void addLocalVariableEntry(int slot,
                                      java.lang.String name,
                                      int begin,
                                      int end)

### emitSimple

    public void emitSimple(java.lang.String mnemonic)

### emit

    public void emit(java.lang.String mnemonic,
                     java.lang.String param)

### emitWithoutLabel

    public void emitWithoutLabel(java.lang.String mnemonic,
                                 java.lang.String param)

### getASM

    public ASM getASM()

### dumpASM

    public void dumpASM(java.lang.String fileName)

### getVersion

    public java.lang.String getVersion()

### setVersion

    public void setVersion(java.lang.String version)

Copyright 2007 IBM Corporation and others. All Rights Reserved.